local camera = {}

function camera:load()
self.pos = vec3(0,0,0)
self.rotX = 0
self.rotY = 0
self.rotZ = 0
self.vel = vec3(1,1,1)
end

function camera:setRot(vec)
self.rotX = vec.x
self.rotY = vec.y
self.rotZ = vec.z
end

function camera:rotate(vec)
self.rotX = self.rotX + vec.x
self.rotY = self.rotY + vec.y
self.rotZ = self.rotZ + vec.z
end

function camera:translate(vec)
self.pos = self.pos + vec
end

function camera:setPos(vec)
self.pos = vec
end

function camera:setVelocity(vec)
self.vx = vec.x
self.vy = vec.y
self.vz = vec.z
end

function camera:update()
if camera.rotY < math.rad(-90) then
camera.rotY = math.rad(-90)
end
if camera.rotY > math.rad(90) then
camera.rotY = math.rad(90)
end

if lk.isDown("w") then
local z = math.rad(math.cos(camera.rotX)) * self.vz
local x = math.rad(math.sin(camera.rotX)) * self.vx
--local y = math.rad(math.sin(camera.rotY)) * self.vy --remove the comment for free camera movement
camera:translate(vec3(x, 0, z))
end
if lk.isDown("s") then
local z = -math.rad(math.cos(camera.rotX)) * self.vz
local x = -math.rad(math.sin(camera.rotX)) * self.vx
--local y = -math.rad(math.sin(camera.rotY)) * self.vy -- remove the comment for free camera movement
camera:translate(vec3(x, 0, z))
end
if lk.isDown("a") then
local z = math.rad(math.sin(camera.rotX)) * self.vz
local x = -math.rad(math.cos(camera.rotX)) * self.vx
camera:translate(vec3(x, 0, z))
end
if lk.isDown("d") then
local z = -math.rad(math.sin(camera.rotX)) * self.vz
local x = math.rad(math.cos(camera.rotX)) * self.vx
camera:translate(vec3(x, 0, z))
end
end

return camera