local loader = require 'loader'

function newObj(path)
local function round(n, d)
  local m = 10^(d or 0)
  return math.floor(n * m + 0.5) / m
end

local o = loader.load(path)
local res = {}
res.f = {}
res.v = {}
res.rf = {}
res.rv = {}
res.c = {1,1,1}

for i,f in pairs(o.f) do
local fc = {}
for k,g in pairs(f) do
if k < 4 then
table.insert(fc, round(g.v, 10))
end
end
table.insert(res.f, fc)

end
for i,v in pairs(o.v) do
table.insert(res.v, vec3(v.x, v.y, v.z))
end

function res:update()
self.rv = {}
self.rf = {}
self.rv = vertex:update(self)
self.rf = face:update(self)
end

function res:draw()
face:draw(self)
end

function res:setColor(r,g,b,a)
if a ~= nil then
self.c = {r,g,b,a}
else
self.c = {r,g,b,1}
end
end

function res:getDepth()
return self.rv[self.f[#self.f][3]].z
end


function res:translate(vec)
for i,v in pairs(self.v) do
v.x = v.x + vec.x
v.y = v.y + vec.y
v.z = v.z + vec.z
end
end

function res:scale(vec)
for i,v in pairs(self.v) do
v.x = v.x*vec.x
v.y = v.y*vec.y
v.z = v.z*vec.z
end
end

function res:getSize()
local h = math.huge
local x = h
local y = h
local z = h
local w = 0
local h = 0
local d = 0
for i,v in pairs(self.v) do
if v.x < x then
x = v.x
end
if v.y < y then
y = v.y
end
if v.z < z then
z = v.z
end
end
for i,v in pairs(self.v) do
if v.x > w then
w = v.x
end
if v.y > h then
h = v.y
end
if v.z > d then
d = v.z
end
end
return vec3(w-x, h-y, d-z)
end

function res:rotate(vec, w)
local c = math.cos
local s = math.sin
for i,v in pairs(self.v) do
local x = v.x*c(vec.x) - v.z*s(vec.x)
local z = v.z*c(vec.x) + v.x*s(vec.x)
v.x = x
v.z = z
local y = v.y*c(vec.y) - v.z*s(vec.y)
local z = v.z*c(vec.y) + v.y*s(vec.y)
v.y = y
v.z = z
local x = v.x*c(vec.z) - v.y*s(vec.z)
local y = v.x*s(vec.z) + v.y*c(vec.z)
v.x = x
v.y = y
end
end

return res
end